#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>

static int open_and_find(const char *file, const char *func)
{
  void *handle;
  int (*fp)(void);
  int err = 0;

  handle = dlopen(file, RTLD_LAZY);
  if (!handle) {
    fprintf(stderr, "could not open %s\n", file ? file : "self");
    err++;
  } else {
    fp = dlsym(handle, func);
    if (!fp) {
      fprintf(stderr, "symbol %s not found\n", func);
      err++;
    } else {
      printf("answer is: %d\n", (*fp)());
    }
    if (dlclose(handle))
      err++;
  }
  return err;
}

int main(void)
{
  if (!open_and_find("foo.so", "foo") && 
      !open_and_find(NULL, "bar"))
    return EXIT_SUCCESS;
  return EXIT_FAILURE;
}

extern int bar(void);
int bar(void)
{
  return 77;
}
